/* Modified for rate 1/3 memory 6 RCPC
 * Copyright 1996 Phil Karn, KA9Q
 */
#include "rcpc.h"
extern unsigned char Partab[];	/* Parity lookup table */

/* encodes data to be transmitted at iteration 's' 
 * returns the number of coded output bits
 */
rcpc_encode( 
unsigned char *symbols,     /* additional parity for next transmission*/
unsigned char *data,        /* raw source data - input */
unsigned int s,             /* s is at what step we are*/
unsigned int nbytes)        /* number of UNCODED DATA bytes to process */ 
{

  int i, encoded=0;
  unsigned char encstate = 0,
          a0, a1, a2; /* ones indicate  bits  to be sent at step 'l' */

  /* we first create new puncturing matrix which has ones only in
     positions which have to be sent at iteration 'l'. For l=0 this
     corresponds   to the highest rate code puncturing matrix. At each 
     consequitive step only additional bits are sent */
 
    if(s==0) {/*first transmission*/
      a0=A0[s];
      a1=A1[s];
      a2=A2[s];
    }
    
    else { /* send only 'new' bits */
      a0=A0[s]^A0[s-1];
      a1=A1[s]^A1[s-1];
      a2=A2[s]^A2[s-1];
    }
	while(nbytes-- != 0){
	  for(i=7;i>=0;i--){
	    encstate = (encstate << 1) | ((*data >> i) & 1);
/*	    
printf("input bit %X  next encstate %X \n",(*data >> i) & 1,encstate & 0x3f);
*/
            if((a0 >> i) & 1){
	      *symbols++ = Partab[encstate & G0];
	      encoded ++;
	    }

            if((a1 >> i) & 1){
	      *symbols++ = Partab[encstate & G1];
	      encoded ++;
	    }
	    
            if((a2 >> i) & 1){
	      *symbols++ = Partab[encstate & G2];
	      encoded ++;
	    }
	  }
	  data++;
	}
     return encoded;
}     















